from functools import wraps
import services
import sims4.resources
from sims4.tuning.instance_manager import InstanceManager
from sims4.resources import Types

def inject(target_function, new_function):
    @wraps(target_function)
    def _inject(*args, **kwargs):
        return new_function(target_function, *args, **kwargs)
    return _inject

def inject_to(target_object, target_function_name):
    def _inject_to(new_function):
        target_function = getattr(target_object, target_function_name)
        setattr(target_object, target_function_name, inject(target_function, new_function))
        return new_function
    return _inject_to

SeSeSimmi_EBT_ObjectIds_1 = (14965,)
SeSeSimmi_EBT_InteractionIds_1 = (2765533718,2733992464,3130403547,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_EBT_AddSuperAffordances_1(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_EBT_InteractionIds_1:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_EBT_ObjectIds_1:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_EBT_ObjectIds_2 = (14965,14845,34678,34679,34680,34682,34684,36369,36370,40340,77507,202931,202932,211714,238959,238960,239031,)
SeSeSimmi_EBT_InteractionIds_2 = (2444611993,3429735524,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_EBT_AddSuperAffordances_2(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_EBT_InteractionIds_2:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_EBT_ObjectIds_2:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_EBT_ObjectIds_3 = (14965,149493,)
SeSeSimmi_EBT_InteractionIds_3 = (2404308410,3011279551,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_EBT_AddSuperAffordances_3(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_EBT_InteractionIds_3:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_EBT_ObjectIds_3:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_EBT_TargetInteractionIds_1 = (2733992464,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_EBT_AddSuperAffordances_BasedOnInteraction_1(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_EBT_TargetInteractionIds_1:
            sa_tuning = affordance_manager.get(sims4.resources.get_resource_key(sa_id, Types.INTERACTION))
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        object_manager = services.get_instance_manager(Types.OBJECT)
        for obj_tuning in object_manager.types.values():
            if obj_tuning is None:
                continue
            if affordance_manager.get(sims4.resources.get_resource_key(13782, Types.INTERACTION)) in obj_tuning._super_affordances:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple

SeSeSimmi_EBT_163702_SnippetId = 163702
SeSeSimmi_EBT_163702_MixerId = (3125202586,2726603007,2754103790,2938595811,3139950054,3673866392,3426912541,3815130752,3593973172,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_EBT_AddMixer_163702(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_EBT_163702_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_EBT_163702_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )
SeSeSimmi_EBT_24508_SnippetId = 24508
SeSeSimmi_EBT_24508_MixerId = (3125202586,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_EBT_AddMixer_24508(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_EBT_24508_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_EBT_24508_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )

